<template>
   <div>
      <div class="section">
         <div class="container">
               <div class="columns is-mobile">
                <div class="column">

                  <article class="media" v-for="chat in myChats.slice().reverse()" v-bind:key="chat.key">
                    <div class="media-content">
                      <div class="content">
                        <p>
                          <strong>{{chat.topic}}</strong> <small>@{{chat.other}}</small> <small>{{chat.start}}</small>
                          <br>
                          {{chat.msg}} - <small class="timeago" :datetime="chat.ts"></small>
                        </p>
                      </div>
                    </div>
                    <div class="media-right">
                      <div class="field">
                        <p class="control">
                          <button class="button"  @click="shout(chat.key)">Open Chat</button>
                        </p>
                      </div>
                    </div>
                  </article>
                  
                </div>
              </div>


         </div>
      </div>
   </div>
</template>

<script>
import { DB } from '@/plugins/firebase.js';
import timeago from 'timeago.js';

export default {
    data: function () {
        return {
            chats: [],
            uid: this.$store.getters.isAuthenticated
        }
    },
    methods: {
        loadChats: function () {
            DB.ref().child('users/' + this.uid + '/chats').on('child_added', (data) => {
                // push the snapshot value into a data attribute
                this.chats.push(data.val())
                console.log(data.val())
            })    
        },
        shout: function(topic) {
          console.log(topic)
          this.$router.push({path: "/chat", query: { id: topic }})
        }
    },
    mounted () {
        this.loadChats();
        
        //topic removed
        DB.ref().child('topics/').on("child_removed", (data) => {
          var deletedPost = data.val().key;
          //var array = this.topics

            for( var i = 0; i < this.topics.length; i++){ 
               if ( this.topics[i].key == deletedPost) {
                 this.topics.splice(i, 1); 
                 console.log(deletedPost + "has been deleted");
               }
            }

        });
      
    },
    updated () {
        timeago().render(document.querySelectorAll('.timeago'));
    },
    computed: {
        myChats: function () {
            var list = []
            var chats = this.chats 
            var myUid = this.uid

            var myChats = chats.forEach(function(chat) {
              let obj = {}
              if (chat.creator.uid == myUid) {
                obj.other = chat.joiner.name
              }
              else {
                obj.other = chat.creator.name
              }

              obj.key = chat.key
              obj.start = chat.start
              obj.topic = chat.topic
              obj.msg = chat.msg.msg
              obj.ts = chat.msg.ts
              list.push(obj)
            })
            
            return list
        },
        otherTopics: function () {
            var topics = this.topics 
            var myUid = this.uid
            var otherTopics = topics.filter(function(topic) {
            	return topic.author != myUid;
            })
            
            return otherTopics
        }
    },
    middleware: 'auth'
}

</script>

<style scoped>
.max-lines {
    max-height: 6em;
    overflow: hidden;
    position: relative;
}

.max-lines:before {
    background: linear-gradient(90deg,hsla(0,0%,100%,0),#fff 75%);
    content: "\200C";
    display: block;
    position: absolute;
    right: 0;
    top: 4.5em;
    width: 30%
}
</style>
